import { IRange } from "../interfaces/IRange";

export class Utils {
  public static getBit(byteValue: number, bitPosition: number): number {
    if (this.isInRange(bitPosition, {min: 0, max: 7}) === false) {
      return -1;
    }

    return (byteValue >> bitPosition) & 0x01;
  }

  public static isInRange(value: number, range: IRange): boolean {
    if (value < range.min) { return false; }
    if (value > range.max) { return false; }

    return true;
  }

  public static getCharsFromRegisterValue(value: number): string {
    console.log('Evaluating', value.toString(16))
    const firstChar = value >> 8;
    console.log('firstChar', firstChar.toString(16))
    const secondChar = value & 0xFF;
    console.log('secondChar', secondChar.toString(16))

    return `${String.fromCharCode(firstChar)}${String.fromCharCode(secondChar)}`
  }
}